package ink.wgink.service.group.service;

import ink.wgink.interfaces.group.IGroupBaseService;
import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.bos.GroupBO;
import ink.wgink.pojo.dtos.ZTreeDTO;
import ink.wgink.pojo.dtos.group.GroupDTO;
import ink.wgink.pojo.result.SuccessResult;
import ink.wgink.pojo.result.SuccessResultList;
import ink.wgink.service.group.pojo.vos.GroupVO;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: IGroupService
 * @Description: 组
 * @Author: wenc
 * @Date: 2019/1/6 3:20 PM
 * @Version: 1.0
 **/
public interface IGroupService extends IGroupBaseService {

    /**
     * 新增组
     *
     * @param params
     * @return
     */
    void save(GroupVO groupVO);

    /**
     * 删除组
     *
     * @param params
     * @return
     */
    void remove(List<String> ids);

    /**
     * 修改组
     *
     * @param params
     * @return
     */
    void update(String groupId, GroupVO groupVO);

    /**
     * 全部组JSON列表
     *
     * @param groupParentId
     * @return
     */
    List<GroupDTO> listAllByParentId(String groupParentId);

    /**
     * 组列表，递归获取全部内容
     *
     * @param params
     * @return
     */
    List<GroupDTO> listAll(Map<String, Object> params);

    /**
     * 组详情
     *
     * @param params
     * @return
     */
    GroupDTO get(Map<String, Object> params);

    /**
     * 组zTree列表
     *
     * @param params
     * @return
     */
    List<ZTreeDTO> listZTree(Map<String, Object> params);

    /**
     * 组EasyUI列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<GroupDTO>> listPage(ListPage page);

    /**
     * 组列表
     *
     * @param params
     * @return
     */
    List<GroupDTO> list(Map<String, Object> params);
}
